﻿//
// App.xaml.cpp
// Implementation of the App.xaml class.
//

#include "pch.h"
#include "App.xaml.h"
#include "MainPage.xaml.h"

using namespace Windows::UI::Xaml;
using namespace MediaCaptureCPP;
using namespace Windows::Foundation;
using namespace Windows::ApplicationModel;
using namespace Windows::ApplicationModel::Activation;
using namespace CppSamplesUtils;

App::App()
{
    InitializeComponent();
    this->Suspending += ref new SuspendingEventHandler(this, &MediaCaptureCPP::App::OnSuspending);
}

void App::OnSuspending(Platform::Object^ sender, Windows::ApplicationModel::SuspendingEventArgs^ pArgs)
{
    auto deferral = pArgs->SuspendingOperation->GetDeferral();
    SuspensionManager::StartSaveAsync(ref new AsyncActionCompletedHandler(
        [=](IAsyncInfo^ asyncInfo, AsyncStatus /*status*/)
    {
        deferral->Complete();
    }));

}

void App::OnLaunched(Windows::ApplicationModel::Activation::LaunchActivatedEventArgs^ pArgs)
{

    if (pArgs->PreviousExecutionState == ApplicationExecutionState::Terminated)
    {
        SuspensionManager::StartRestoreAsync(ref new AsyncActionCompletedHandler(
            [=](IAsyncInfo^ asyncInfo, AsyncStatus /*status*/)
        {
            Window::Current->Content = ref new MainPage();
            Window::Current->Activate();
        }));
    }
    else
    {
        Window::Current->Content = ref new MainPage();
        Window::Current->Activate();
    }
}
