﻿//
// MainPage.xaml.h
// Declaration of the MainPage.xaml class.
//

#pragma once

#include "pch.h"
#include "MainPage.g.h"

using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::Graphics::Display;
using namespace Windows::UI::ViewManagement;
using namespace Windows::Devices::Enumeration;
#define VIDEO_FILE_NAME "video.mp4"
#define AUDIO_FILE_NAME "audio.m4a"
#define PHOTO_FILE_NAME "photo.jpg"

namespace MediaCaptureCPP
{
    public ref class MainPage sealed
    {
    public:
        MainPage();
        ~MainPage();

    private:
        void ScenarioList_SelectionChanged(Object^ sender, SelectionChangedEventArgs^ e);
        void Footer_Click(Object^ sender, RoutedEventArgs^ e);
        Windows::Foundation::EventRegistrationToken _viewStateHandlerToken;
        void Page_ViewStateChanged(ApplicationView^ sender, ApplicationViewStateChangedEventArgs^ e);
        void Scenario1Init();
        void Scenario1Reset();
        void Scenario2Init();
        void Scenario2Reset();
        void Scenario3Init();
        void Scenario3Reset();
        void ResetAll();

		void InitializeScenario();     

        void Suspending(Object^ sender,  Windows::ApplicationModel::SuspendingEventArgs^ e);
        void Resuming(Object^ sender, Object^ e);
        
        void lstEnumedDevices_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::SelectionChangedEventArgs^ e);
        void EnumerateWebcamsAsync();        
		void OnWebcamsEnumeratedCB(Windows::Foundation::IAsyncOperation<DeviceInformationCollection^>^ asyncOp, Windows::Foundation::AsyncStatus status);
        void OnWebcamsEnumeratedComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);

        void btnStartDevice_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void OnStartDeviceCB(Windows::Foundation::IAsyncAction^ op, Windows::Foundation::AsyncStatus status);
        void OnStartDeviceComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);
                
        void btnStartPreview_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void OnStartPreview(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);
        void OnStartPreviewCB(Windows::Foundation::IAsyncAction^ op, Windows::Foundation::AsyncStatus status);
        void OnStartPreviewComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);        
        void OnStopPreviewCB(Windows::Foundation::IAsyncAction^ op, Windows::Foundation::AsyncStatus status);
        void OnStopPreviewComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);

        void btnStartStopRecord_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void OnRecordFileCreatedCB(Windows::Foundation::IAsyncOperation<Windows::Storage::StorageFile^>^ storageFile, Windows::Foundation::AsyncStatus status);
        void OnRecordFileCreatedComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);                
        void OnStartRecordCB(Windows::Foundation::IAsyncAction^ op,Windows::Foundation::AsyncStatus status);
        void OnStartRecordComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);
        void OnStopRecordCB(Windows::Foundation::IAsyncAction^ op, Windows::Foundation::AsyncStatus asyncStatus);
        void OnStopRecordComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);
        void OnRecordFileOpenedCB(Windows::Foundation::IAsyncOperation<Windows::Storage::Streams::IRandomAccessStream^>^ videoStream, Windows::Foundation::AsyncStatus status);
        void OnRecordFileOpenedComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);
        
        void btnTakePhoto_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);        
        void OnPhotoFileCreatedCB(Windows::Foundation::IAsyncOperation<Windows::Storage::StorageFile^>^ storageFile,Windows::Foundation::AsyncStatus status);
        void OnPhotoFileCreatedComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);                
        void OnTakePhotoCB(Windows::Foundation::IAsyncAction^ op, Windows::Foundation::AsyncStatus status);
        void OnTakePhotoComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);
        void OnPhotoFileOpenedCB(Windows::Foundation::IAsyncOperation<Windows::Storage::Streams::IRandomAccessStream^>^ photoStream, Windows::Foundation::AsyncStatus status);
        void OnPhotoFileOpenedComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);

        void chkAddRemoveEffect_Checked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void chkAddRemoveEffect_Unchecked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void OnEffectAddedOrRemovedCB(Windows::Foundation::IAsyncAction^ op, Windows::Foundation::AsyncStatus status);
        void OnEffectAddedorRemovedComplete(Platform::Object^ sender, Windows::UI::Core::InvokedHandlerArgs^ e);                

        void SetupVideoDeviceControl(Windows::Media::Devices::MediaDeviceControl^ videoDeviceControl, Slider^ slider);
        void sldBrightness_ValueChanged(Platform::Object^ sender,  Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ e);
        void sldContrast_ValueChanged(Platform::Object^ sender,  Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ e);

        void ShowStatusMessage(Platform::String^ text);
        void ShowExceptionMessage(Platform::Exception^ ex);

        void EnableButton(bool enabled, Platform::String ^name);
        void SwitchRecordButtonContent();

        Windows::Media::Capture::MediaCapture^ m_mediaCaptureMgr;
        Windows::Storage::StorageFile^ m_photoStorageFile;
        Windows::Storage::StorageFile^ m_recordStorageFile;
        bool m_bRecording;
        bool m_bEffectAdded;
        bool m_bSuspended;
        bool m_bPreviewing;
        DeviceInformationCollection^ m_devInfoCollection;

    };
}

